#include "maintest.h"
#include "../common/message.h"
#include <canbus/canMsg.h>
#include <canbus/LearnModeRequest.h>
namespace robot {
namespace test {

std::string Maintest::Name() const { return "mainTest"; }

int Maintest::Init(){
    LOG(INFO)<<Name()<<" mainTest init...";
    node_handle_.reset(new ros::NodeHandle());
    return 0;
}

int Maintest::Start(){
    LOG(INFO)<<" mainTest start...";
    ros::Rate loop_rate(10);
    ros::Subscriber sub = node_handle_->subscribe("canDataAnalysis", 20000, chatterCallback);
    ros::ServiceClient client = node_handle_->serviceClient<canbus::LearnModeRequest>(robot::common::LearnModeService);
    //data receive
    while(ros::ok())
    {
        canbus::LearnModeRequest srv;
        srv.request.uiClrAccTbl = 1;
        srv.request.uiClrBrkTbl = 1;
        srv.request.uiClrClchTbl =1;
        srv.request.uiClrSftTbl = 1;
        srv.request.uiClrStrTbl = 1;
        srv.request.uiPsngLrnReq =1;
        srv.request.uiSftAutLrnFnsConf = 1;
        srv.request.uiSftPsngLrnReq = 1;
        srv.request.uiStpAutLrn =1;
         srv.request.uiSysLrnReq =1;
         if (client.call(srv))
         {
             LOG(INFO)<<srv.response.uiReturn;
         }
        ros::spinOnce();
        loop_rate.sleep();
     }


    //ros::spin();
    return 0;
}
void Maintest::Stop(){
    LOG(INFO)<<" mainTest stop..."; 
    node_handle_.release();
    return ;
}

void Maintest::chatterCallback(const canbus::canMsg::ConstPtr& msg)
{
    LOG(INFO)<<" Msg CanData :" << "ID:" << msg->id << ",Data:"<<msg->data;
        //ROS_INFO("I heard: [%s]", msg.data);
}

}
}
